// Copyright (c) 2020 Giorgos Vougioukas
//
// The license can be found in the LICENSE file.

#ifndef _TERPSICHORE_VOLUME_EXACT_WINDOW_H_
#define _TERPSICHORE_VOLUME_EXACT_WINDOW_H_

#include "terpsichore/definitions.h"

#include "WDL/wingui/wndsize.h"
#include "WDL/heapbuf.h"

class RST_ExactVolWnd
{
public:
  RST_ExactVolWnd();
  ~RST_ExactVolWnd();

  HWND Handle() const;

  static WDL_DLGRET ST_ExactVolWndProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);

private:
  WDL_DLGRET ExactVolWndProc(UINT msg, WPARAM wparam, LPARAM lparam);
  void OnInitDialog(WPARAM wparam, LPARAM lparam);
  void OnDestroy(WPARAM wparam, LPARAM lparam);
  void OnCommand(WPARAM wparam, LPARAM lparam);

  HWND m_hwnd;
  HWND m_edit;
};

#endif // _TERPSICHORE_VOLUME_EXACT_WINDOW_H_
